/**********************************************************************/
/***                                                                  */
/***        Author: Luis Eduardo Gamboa Guzmn                        */
/***        Last Updated: June 15th 2005                              */
/***                                                                  */
/***        Facultad de Ingeniera Elctrica                          */
/***        Universidad Michoacana de San Nicolas de Hidalgo          */
/***                                                                  */
/**********************************************************************/

#ifndef __ARITHMETICCODER_H__
#define __ARITHMETICCODER_H__


#include "types.h"

struct arcoder
{
	// bit operations
	unsigned char mBitBuffer;
	unsigned char mBitCount;

	// in-/output stream
	BYTE *mByteBuffer;
	int *ByteBufferLength;
	int ByteBufferPointer;

	// encoder & decoder
	unsigned int mLow;
	unsigned int mHigh;
	unsigned int mStep;
	unsigned int mScale;

	// decoder
	unsigned int mBuffer;
};
typedef struct arcoder ARCODER;

enum ModeE
{
	MODE_ENCODE = 0,
	MODE_DECODE
};

struct model  
{
	ARCODER mAC;
	BYTE *mSource;
	int mSourcePointer;
	int nSource;
	BYTE *mTarget;
	int mTargetPointer;
	int nTarget;
	unsigned int mCumCount[ 257 ];
	unsigned int mTotal;
};
typedef struct model MODEL;
/* AC */
void initarithmeticcoder(ARCODER *ac);
void ACSetBuffer(BYTE *buffer,int *length,ARCODER *ac);
void ACEncode(const unsigned int low_count, const unsigned int high_count,const unsigned int total,ARCODER *ac);
void ACEncodeFinish(ARCODER *ac);
void ACDecodeStart(ARCODER *ac);
unsigned int ACDecodeTarget(const unsigned int total,ARCODER *ac);
void ACDecode(const unsigned int low_count,const unsigned int high_count,ARCODER *ac);
void ACSetBit(const unsigned char bit,ARCODER *ac);
void ACSetBitFlush(ARCODER *ac);
unsigned char ACGetBit(ARCODER *ac);

/* Model */
void ModelProcess(BYTE *source,BYTE *target,int Nsource,int *Ntarget,enum ModeE mode,MODEL *mmodel);
void initmodel(MODEL *mmodel);
void ModelEncode(MODEL *mmodel);
void ModelDecode(MODEL *mmodel);

int arithmeticencode(BYTE *input,BYTE *output,int Ninput);
int arithmeticdecode(BYTE *input,BYTE *output,int Ninput);

#endif
