#include "huffman.h"
#include <malloc.h>

void prueba(void)
{
	short int pr=(short int)0xBAAB;
	int buf;
	BYTE a;
	FILE *f=fopen("prueba","wb+");
	union bytefields juan;

	fwrite(&pr,sizeof(short int),1,f);
	fwrite(&pr,sizeof(short int),1,f);
	fwrite(&pr,sizeof(short int),1,f);

	fseek(f,0,SEEK_SET);
	fread(&buf,sizeof(int),1,f);

	printf("int: 0x%x\n",buf);
	
	fseek(f,0,SEEK_SET);
	fread(&a,sizeof(BYTE),1,f);
	printf("byte: 0x%x",a);
	juan.b=a;
	printf(" %d%d%d%d%d%d%d%d\n",juan.b0,juan.b1,juan.b2,juan.b3,juan.b4,juan.b5,juan.b6,juan.b7);
	/*fread(&a,sizeof(BYTE),1,f);
	printf(" 0x%x",a);
	fread(&a,sizeof(BYTE),1,f);
	printf(" 0x%x",a);
	fread(&a,sizeof(BYTE),1,f);
	printf(" 0x%x\n",a);

	juan.b=a;
	printf("%d  %d%d%d%d%d%d%d%d\n",sizeof(union bytefields),juan.b0,juan.b1,juan.b2,juan.b3,juan.b4,juan.b5,juan.b6,juan.b7);*/

	fclose(f);
}

int huffmanencode(const char *in,const char *out,int nbits)
{
	int N=0x1<<nbits;
	int i,j;
	long lfilesize,curbyte;
	int numbytes,numbits;
	DWORD *freq[2];
	BYTE *bext;
	BYTE *buffer;
	BYTE aux;
	DWORD *huffmancodes;
	union bytefields bf;
	FILE *fin;
	FILE *fout;
	
	i=nbits;
	j=0;
	while(i%2==0 && j<3)
	{
		i/=2;
		j++;
	}
	numbytes=i;
	numbits=numbytes*8;

	bext=(BYTE *)malloc(sizeof(BYTE)*numbits);
	buffer=(BYTE *)malloc(sizeof(BYTE)*numbytes);
	freq[0]=(DWORD *)malloc(sizeof(DWORD)*N);
	freq[1]=(DWORD *)malloc(sizeof(DWORD)*N);
	huffmancodes=(DWORD *)malloc(sizeof(DWORD)*N);


	//prueba();
	
	fin=fopen(in,"rb");
	//fout=fopen(out,"wb+");

	if(!fin || !fout)
		return -1;

	fseek(fin,0,SEEK_END);
	lfilesize=ftell(fin);
	fseek(fin,0,SEEK_SET);

	if(lfilesize%(long)numbytes)
	{
		printf("Impossible to compute %d bit Huffman code on a %d bytes file\n\tthe file size must be divisible by %d",nbits,lfilesize,numbytes);
		return -2;
	}
	
	for(i=0;i<N;i++)
	{
		freq[0][i]=i;
		freq[1][i]=0;
	}

	curbyte=0;
	printf("Number of bytes %d\n",numbytes);
	printf("File size %d\n",lfilesize);
	while(curbyte<lfilesize)
	{
		fread(buffer,sizeof(BYTE),numbytes,fin);
		curbyte+=numbytes;
	
		for(i=0;i<numbytes;i++)
		{
			//printf("0x%x\n",buffer[i]);
			bf.b=buffer[i];
			bext[(i*8)+0]=bf.b0;
			bext[(i*8)+1]=bf.b1;
			bext[(i*8)+2]=bf.b2;
			bext[(i*8)+3]=bf.b3;
			bext[(i*8)+4]=bf.b4;
			bext[(i*8)+5]=bf.b5;
			bext[(i*8)+6]=bf.b6;
			bext[(i*8)+7]=bf.b7;
		}
		i=0;
		while((i+nbits)<=numbits)
		{
			for(aux=0x0,j=0;j<nbits;j++)
			{
				//printf("%d %x\n",i+j,bext[i+j]);
				switch(bext[i+j])
				{
					case 0:
						aux<<=1;
						break;
					case 1:
						aux=(aux<<1)+0x1;
						break;
				}
			}
			i+=j;
			//printf("%x\n\n",aux);
			freq[1][aux]++;
		}

	}
	sortfreq(freq,N);
	for(i=0;i<N;i++)
	{
		printf("0x%x %d\n",freq[0][i],freq[1][i]);
	}
	
	free(bext);
	free(huffmancodes);
	free(buffer);
	free(freq[0]);
	free(freq[1]);
	fclose(fin);
}

void createhuffmancodes1(DWORD *huffmancodes,int N)
{
}

void sortfreq(DWORD *freq[2],int N)
{
	int j,i,N1=N-1;
	DWORD aux;
	/* plain old crappy bubble sorting */
	for(j=0;j<N;j++)
	{
		for(i=0;i<N1;i++)
		{
			if(freq[1][i]<freq[1][i+1])
			{
				aux=freq[1][i+1];
				freq[1][i+1]=freq[1][i];
				freq[1][i]=aux;
			
				aux=freq[0][i+1];
				freq[0][i+1]=freq[0][i];
				freq[0][i]=aux;
			}
		}
	}
}

