/**********************************************************************/
/***                                                                  */
/***        Author: Luis Eduardo Gamboa Guzmn                        */
/***        Last Updated: May 17th 2005                               */
/***                                                                  */
/***        Facultad de Ingeniera Elctrica                          */
/***        Universidad Michoacana de San Nicolas de Hidalgo          */
/***                                                                  */
/**********************************************************************/

#include "types.h"

/*void printfloat(float f)
{
	union 
	{
		float f;
		DWORD i;
	}aux;
	int i;

	aux.f=f;

	for(i=0;i<1;i++)
	{
		printf("%d",(aux.i & 0x80000000)>>31);
		aux.i = aux.i<<1;
	}
	printf(" ");
	for(;i<9;i++)
	{
		printf("%d",(aux.i & 0x80000000)>>31);
		aux.i = aux.i<<1;
	}
	printf(" ");
	for(;i<32;i++)
	{
		printf("%d",(aux.i & 0x80000000)>>31);
		aux.i = aux.i<<1;
	}

	printf("\n");
}

void printfloat8(FLOAT8 *f)
{
	DWORD i;
	printf("%d ",f->sign);
	i=f->exp;
	printf("%d%d%d ",(i&0x4)>>2,(i&0x2)>>1,i&0x1);
	i=f->mantisa;
	printf("%d%d%d%d\n",(i&0x8)>>3,(i&0x4)>>2,(i&0x2)>>1,i&0x1);
}

void printfloat16(FLOAT16 *f)
{
	DWORD i;
	printf("%d ",f->sign);
	i=f->exp;
	printf("%d%d%d%d%d ",(i&0x10)>>4,(i&0x8)>>3,(i&0x4)>>2,(i&0x2)>>1,i&0x1);
	i=f->mantisa;
	printf("%d%d%d%d%d%d%d%d%d%d\n",(i&0x200)>>9,(i&0x100)>>8,(i&0x80)>>7,(i&0x40)>>6,(i&0x20)>>5,(i&0x10)>>4,(i&0x8)>>3,(i&0x4)>>2,(i&0x2)>>1,i&0x1);
}*/

float float8tofloat(FLOAT8 *in)
{ 
	union 
	{
		float f;
		DWORD i;
	}aux;
	DWORD iaux;


	aux.i=0;
	
	iaux=in->sign;
	aux.i+= iaux << 31;

	iaux= in->exp;
	switch(iaux)
	{
		case 0x0:
			break;
		default:
			iaux--;
			if(iaux&0x4)
				aux.i = aux.i | ((iaux&0x4)<<28) | ((iaux&0x3)<<23);
			else
				aux.i = aux.i | ((iaux&0x4)<<28) | (0x1f<<25) | ((iaux&0x3)<<23);
	}

	iaux=in->mantisa;
	aux.i = aux.i | iaux<<19;
	
	return aux.f;
}

void floattofloat8(float in,FLOAT8 *out)
{
	union 
	{
		float f;
		DWORD i;
	}aux;
	int iaux;

	if(in<0.125 && in>-0.125)
	{
		out->sign=0x0;
		out->exp=0x0;
		out->mantisa=0x0;
		return;
	}
	aux.f=in;
	out->sign= (aux.i&0x80000000)>>31;

	iaux=(aux.i&0x7f800000)>>23;
	iaux++;
	out->exp= ((iaux&0x80)>>5) | (iaux&0x3);

	out->mantisa= (aux.i&0x00780000)>>19;

}

float float16tofloat(FLOAT16 *in)
{ 
	union 
	{
		float f;
		DWORD i;
	}aux;
	DWORD iaux;

	//printfloat16(in);

	aux.i=0;
	
	iaux=in->sign;
	aux.i+= iaux << 31;

	iaux= in->exp;
	switch(iaux)
	{
		case 0x0:
			break;
		default:
			iaux--;
			if(iaux&0x10)
				aux.i = aux.i | ((iaux&0x10)<<26) | ((iaux&0xf)<<23);
			else
				aux.i = aux.i | ((iaux&0x10)<<26) | (0x7<<27) | ((iaux&0xf)<<23);
	}

	iaux=in->mantisa;
	aux.i = aux.i | iaux<<13;
	
	//printfloat(aux.f);
	return aux.f;
}

void floattofloat16(float in,FLOAT16 *out)
{
	union 
	{
		float f;
		DWORD i;
	}aux;
	int iaux;

	if(in<3.0517579e-5 && in>-3.0517579e-5)
	{
		out->sign=0x0;
		out->exp=0x0;
		out->mantisa=0x0;
		return;
	}
	//printfloat(in);

	aux.f=in;
	out->sign= (aux.i&0x80000000)>>31;

	iaux=(aux.i&0x7f800000)>>23;
	iaux++;
	out->exp= ((iaux&0x80)>>3) | (iaux&0xf);

	out->mantisa= (aux.i&0x007fe000)>>13;

}
